unit Un_30_1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls;

type
  TForm1 = class(TForm)
    Image1: TImage;
    procedure Image1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Image1MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure Image1MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

  TMouseState = (msNonnal, msDragging);
var
  Form1: TForm1;
  OldPos, NewPos: TPoint;
  FMouseState : TMouseState;

implementation

{$R *.dfm}

procedure TForm1.Image1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  //""  .
  FMouseState := msDragging;
  //  .
  OldPos := Point(X, Y);
  //   .
  Screen.Cursor := crDrag;
end;

procedure TForm1.Image1MouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin
  if FMouseState = msDragging then //  .
  begin
     //  .
     NewPos := Point(X - OldPos.X, Y - OldPos.Y);
     //  .
     Image1.Parent.ScrollBy(NewPos.X, NewPos.Y);
  end;
end;

procedure TForm1.Image1MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  FMouseState := msNonnal; //""  .
  Screen.Cursor := crDefault; //  -  .
end;

end.
